#!/bin/bash

# TODO: devine marker string variable
# TODO: show non-compiling projects in logfile
#rm -rf Unpack
mkdir -p Unpack
rm -f ~/results.log

for zip in $( ls *.zip); do
  fbname=$(basename "$zip" .zip)
  echo $fbname
  pushd Unpack
  unzip ../$fbname.zip
  rm -rf RemoteSystemsTempFiles
  nodeCount=`ls|wc -l`
  dirCount=`ls -l|grep ^d|wc -l`

  if [[ 1 = $nodeCount && 1 =  $dirCount ]]; then
      echo "Found exactly one directory component" 
      mv * project
      if [ -f project/pom.xml ]; then
	  echo "found pom.xml"
	  cd project
	  mvn clean eclipse:clean; rm -rf .settings/ A1.log
	  rm -rf pom.xml src/test/java
	  tar zxf ~/solutionTest.tgz
	  mvn -Dmaven.test.skip=true package
	  reachedPoints=`java -jar target/sw1klausur-0.9.jar|grep myGoikKlausurMarkeri| sed -e s/myGoikKlausurMarkeri://`
	  echo "$fbname $reachedPoints" >> ~/results.log
      else 
	  echo "$fbname : No pom.xml found in project" >> ~/results.log
      fi
  else 
      echo "$fbname : Found more than one directory component" >> ~/results.log
  fi

  popd
  rm -rf Unpack/*
done


#end
