package de.hdm_stuttgart.mi.sda1.sql2catalog;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import org.jdom2.Element;

import de.hdm_stuttgart.mi.sda1.sql2catalog.model.Product;

/**
 * Reading product data
 *
 */
public class RdbmsAccess {

   static final EntityManager em;

   static {
      final EntityManagerFactory emFactory =  Persistence.createEntityManagerFactory("none");
      em = emFactory.createEntityManager();
   }

   /**
    * Append element to XML tree.
    * @param root
    */
   public void appendProducts(final Element root) {
      final EntityTransaction transaction = em.getTransaction();
      transaction.begin();

      for (final Product p: em.createQuery("SELECT p FROM Product p", Product.class).getResultList()) {

         final Element productElement = new Element("product");
         root.addContent(productElement);
         productElement.setAttribute("id", "" + p.getId());

         productElement.addContent(new Element("name").addContent(p.getName()));

         p.getDescriptions().stream().forEach(description -> {
            productElement.addContent(new Element("description").addContent(description.getDescription()));
         });

         p.getAge().ifPresent(age -> productElement.addContent(new Element("age").addContent(age.toString())));
      }
      transaction.commit();
   }
}