package de.hdm_stuttgart.mi.exam.unitmarking;

import java.util.Set;

import org.junit.runner.JUnitCore;

public class RunTests {
   
   static public final MarkingListener markingListener = new MarkingListener();
   
   @SafeVarargs
   public static void exec(Class<? extends Object> ... classz) {
      
      final JUnitCore jc = new JUnitCore();
      jc.addListener(markingListener);
      
      System.setOut(DummyPrintStream.out);
      jc.run(classz);
      System.setOut(DummyPrintStream.systemDotOut);
      killStillRunningJUnitTestcaseThreads();
      System.out.println(RunTests.getMarking());
    }
    static public String getMarking() {
       return markingListener.getPointSumms();
    }
    
    @SuppressWarnings("deprecation")
    static public void killStillRunningJUnitTestcaseThreads() {
        Set<Thread> threadSet = Thread.getAllStackTraces().keySet();
        for (Thread thread : threadSet) {
            if (!(thread.isDaemon())) {
                final StackTraceElement[] threadStackTrace = thread.getStackTrace();
                if (threadStackTrace.length > 1) {
                    StackTraceElement firstMethodInvocation = threadStackTrace[threadStackTrace.length - 1];
                    if (firstMethodInvocation.getClassName().startsWith("org.junit")) {
                        // HACK: must use deprecated method
                        thread.stop();
                    }
                }
            }
        }
    }
}
